* Create an instance of the SQLDatabaseMgmt class.

set path to home() + 'tools\xsource\vfpsource\dataexplorer'
loSQL = newobject('SQLDatabaseMgmt', 'DataMgmt_SQL.prg')

* Get a collection of available servers and display the databases for each
* one, then display the tables for the first database.

*** This only seems to work if you have an internet connection!
loServers = loSQL.GetAvailableServers()
for each loServer in loServers
	if loSQL.Connect(loServer.Name)
		messagebox('Connected to server ' + loServer.Name)
		loDatabases = DisplayDatabases(loSQL, loServer.Name)
		if loDatabases.Count > 0
			loDatabase = loDatabases.Item(1)
			DisplayTables(loSQL, loDatabase.Name)
		else

* This is a kludge: for some reason, GetDatabases fails on my (local) server.

			DisplayTables(loSQL, 'Northwind')
		endif loDatabases.Count > 0
	else
		messagebox('Could not connect to ' + loServer.Name)
	endif loSQL.Connect(loServer.Name)
next loServer
set path to

* Display the databases in the current server.

function DisplayDatabases(toSQL, tcServer)
local loDatabases, ;
	lcDatabases, ;
	loDatabase
loDatabases = toSQL.GetDatabases()
if loDatabases.Count > 0
	lcDatabases = ''
	for each loDatabase in loDatabases
		lcDatabases = lcDatabases + iif(empty(lcDatabases), '', chr(13)) + ;
			loDatabase.Name + ' (' + loDatabase.Owner + ')'
	next loDatabase
	messagebox(lcDatabases, 0, 'Databases in ' + tcServer)
else
	messagebox('Could not retrieve databases for ' + tcServer + chr(13) + ;
		chr(13) + toSQL.LastError)
endif loDatabases.Count > 0
return loDatabases

* Display the tables in the specified database.

function DisplayTables(toSQL, tcDatabase)
local loTables, ;
	lcTables, ;
	loTable
toSQL.DatabaseName = tcDatabase
loTables = toSQL.GetTables()
if loTables.Count > 0
	lcTables = ''
	for each loTable in loTables
		lcTables = lcTables + iif(empty(lcTables), '', chr(13)) + ;
			loTable.Name + ' (' + loTable.Owner + ')'
	next loTable
	messagebox(lcTables, 0, 'Tables in ' + tcDatabase)
else
	messagebox('Could not retrieve tables for ' + tcDatabase + chr(13) + ;
		chr(13) + toSQL.LastError)
endif loTables.Count > 0
return
